// -*-C++-*-
//
//  This file is part of Siena, a wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Antonio Carzaniga <carzanig@cs.colorado.edu>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 1998-2002 University of Colorado
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: yysfftypes.h,v 1.1 2002/11/10 00:53:31 carzanig Exp $
//
#ifndef _YYSFFTYPES_H
#define _YYSFFTYPES_H

#include <siena/types.h>

#include "yysff.h"
#include "simple_fwd_types.h"

using namespace std;
using namespace siena;

struct sffstype {
    const string *		fname;
    unsigned			nlin;
    union {
	int			int_v;
	double			double_v;
	bool			bool_v;
	operator_id		op;
	string_t *		str_v;
	simple_message *	message;
	simple_value *		value;
	simple_op_value *	constraint;
	simple_predicate *	predicate;
	simple_filter *		filter;
    };

    string			str;

    sffstype(): str() {};
};
/*
 *  we can't typedef sffstype YYSTYPE
 *  we must #define YYSTYPE to prevent bison from #defining it
 */
#define YYSTYPE sffstype

#define YY_DECL int yylex(YYSTYPE * yylval)
extern YY_DECL;

extern unsigned yysffnlin;
extern string yysfffname;

#endif
